## optipng 0.5.5

=== man/Makefile ===
#
# Makefile for the OptiPNG manual page
#


# System directories
prefix=/usr/local
mandir=${prefix}/man
man1dir=${mandir}/man1


# Targets
all: optipng.txt optipng.ps optipng.html

optipng.txt: optipng.1
	nroff -man -c $< | col -bx | uniq > $@

optipng.ps: optipng.1
	#troff -man $< > $@
	groff -man -Tps $< > $@

optipng.html: optipng.1
	groff -man -Thtml $< > $@

install: optipng.1
	-@if [ ! -d ${man1dir} ]; then mkdir -p ${man1dir}; fi
	-@rm -f ${man1dir}/optipng.1
	cp -p optipng.1 ${man1dir}

uninstall:
	rm -f ${man1dir}/optipng.1

clean:
	#rm -f optipng.txt
	rm -f optipng.ps optipng.html

## optipng 0.6.4

=== man/Makefile ===
##
## Makefile for the OptiPNG manual page
##


# System directories
prefix=/usr/local
mandir=${prefix}/man
man1dir=${mandir}/man1


# Targets
all: optipng.1.txt optipng.1.ps optipng.1.pdf optipng.1.html

optipng.1.txt: optipng.1
	nroff -man -c $< | col -b -x | uniq > $@

optipng.1.ps: optipng.1
	#troff -man $< > $@
	groff -man -Tps -P-g $< > $@

optipng.1.pdf: optipng.1.ps
	ps2pdf $< $@

optipng.1.html: optipng.1
	#man2html $< > $@
	groff -man -Thtml -P-l $< > $@

install: optipng.1
	mkdir -p ${man1dir}
	cp -f -p optipng.1 ${man1dir}

uninstall:
	rm -f ${man1dir}/optipng.1

dist: optipng.1.txt optipng.1.pdf optipng.1.html
	cp -f -p optipng.1.txt ../doc/manual.txt
	cp -f -p optipng.1.pdf ../doc/manual.pdf
	cp -f -p optipng.1.html ../doc/manual.html

clean:
	rm -f optipng.1.txt
	rm -f optipng.1.ps
	rm -f optipng.1.pdf
	rm -f optipng.1.html

distclean: dist clean

=== debian/changelog ===
optipng (0.6.4-1ubuntu0.14.04.2) trusty-security; urgency=medium

  * SECURITY UPDATE: integer overflow in minitiff_read_info
    - debian/patches/CVE-2017-1000229.patch: add count check in
      lib/pngxtern/minitiff/tiffread.c.
    - CVE-2017-1000229

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 23 Nov 2017 13:45:05 -0500

optipng (0.6.4-1ubuntu0.14.04.1) trusty-security; urgency=medium

  * SECURITY UPDATE: out of bounds read/writes via malformed image
    - debian/patches/CVE-2016-2191.patch: properly check bounds in
      src/pngxtern/pngxrbmp.c.
    - CVE-2016-2191
  * SECURITY UPDATE: denial of service via use-after-free
    - debian/patches/CVE-2015-7801.patch: fix free in src/opngoptim.c.
    - CVE-2015-7801
  * SECURITY UPDATE: harmless out-of-bounds read
    - debian/patches/CVE-2015-7802.patch: properly set last_byte in
      src/gifread/gifread.c.
    - CVE-2015-7802

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 13 Apr 2016 13:57:46 -0400

optipng (0.6.4-1build1) quantal; urgency=low

  * Rebuild for new armel compiler default of ARMv5t.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 08 Oct 2012 08:37:00 +0100

optipng (0.6.4-1) unstable; urgency=low

  * New upstream release;
  * Convert package to the new format 3.0 (quilt);
  * Register OptiPNG's manual.pdf in doc-base;
  * Updated Standards-Version to 3.8.4 (no changes needed).

 -- Nelson A. de Oliveira <naoliv@debian.org>  Wed, 17 Mar 2010 12:26:17 -0300

optipng (0.6.3-1) unstable; urgency=low

  * New upstream release;
  * Updated Standards-Version to 3.8.3 (no changes needed).

 -- Nelson A. de Oliveira <naoliv@debian.org>  Tue, 18 Aug 2009 17:14:28 -0300

optipng (0.6.2.1-1) unstable; urgency=high

  * New upstream release:
    - Fix an array overflow vulnerability.

 -- Nelson A. de Oliveira <naoliv@debian.org>  Thu, 26 Feb 2009 15:48:25 -0300

optipng (0.6.2-1) experimental; urgency=low

  * New upstream release;
  * Fix broken link /usr/share/doc/optipng/changelog.gz;
  * OptiPNG now produces a less verbose output (Closes: #457772).

 -- Nelson A. de Oliveira <naoliv@debian.org>  Tue, 11 Nov 2008 13:26:52 -0200

optipng (0.6.1-2) unstable; urgency=low

  * Update debian/copyright.

 -- Nelson A. de Oliveira <naoliv@debian.org>  Sat, 26 Jul 2008 19:14:00 -0300

optipng (0.6.1-1) unstable; urgency=low

  * New upstream release;
  * OptiPNG no longer writes a larger image (Closes: #491619);
  * Removed patches/optipng-0.6.0.1.diff (fixed upstream);
  * Updated debian/rules for the new build system.

 -- Nelson A. de Oliveira <naoliv@debian.org>  Sat, 26 Jul 2008 18:51:23 -0300

optipng (0.6-1) unstable; urgency=low

  * New upstream release;
  * Fix resolution change when optimizing files (Closes: #446920);
  * Bump Standards-Version to 3.8.0 (no changes needed);
  * Moved homepage from long description to its own field;
  * New patch patches/optipng-0.6.0.1.diff, fixing the build system.

 -- Nelson A. de Oliveira <naoliv@debian.org>  Fri, 20 Jun 2008 00:43:42 -0300

optipng (0.5.5-1) unstable; urgency=medium

  * New upstream release;
  * Removed patches/opngreduc.patch (applied upstream);
  * Medium urgency since it's basically a bug-fix release.

 -- Nelson A. de Oliveira <naoliv@debian.org>  Sat,  3 Feb 2007 13:35:43 -0200

optipng (0.5.4+0-1) unstable; urgency=medium

  * New maintainer address;
  * Stripped unneeded libpng, zlib and some other files from .orig.tar.gz;
  * New patch debian/patches/opngreduc.patch to avoid OptiPNG failing with
    some true-color RGB images;
  * Added tags on debian/control;
  * Medium urgency to get it on Etch.

 -- Nelson A. de Oliveira <naoliv@debian.org>  Wed,  6 Dec 2006 02:32:02 -0200

optipng (0.5.4-2) unstable; urgency=medium

  * libpng version 1.2.13 available on Debian:
    - OptiPNG is now dynamically linked against Debian's libpng;
    - Updated debian/control (included build-depends on libpng12-dev);
    - Updated debian/rules (now using "unix-secure.mak" to compile dynamically
      against zlib and libpng);
    - Removed debian/patches/* (not needed anymore);
    - Removed README.Debian (it's not necessary anymore to explain why we are
      linking OptiPNG statically with libpng).
    - medium urgency since it will be really good to have this package on
      Etch, using Debian's libpng instead its own (less security work, etc).

 -- Nelson A. de Oliveira <naoliv@gmail.com>  Sun, 19 Nov 2006 02:14:06 -0200

optipng (0.5.4-1) unstable; urgency=low

  * New upstream release;
  * New patch debian/patches/gcc.mak.patch to build OptiPNG dynamically
    linked against zlib.

 -- Nelson A. de Oliveira <naoliv@gmail.com>  Sat, 12 Aug 2006 03:22:18 -0300

optipng (0.5.3-1) unstable; urgency=low

  * New upstream release;
  * debian/control: updated OptiPNG homepage;
  * Removed patches debian/patches/optipng.1.patch and
    debian/patches/optipng.c.patch (both applied upstream).

 -- Nelson A. de Oliveira <naoliv@gmail.com>  Thu, 27 Jul 2006 01:12:41 -0300

optipng (0.5.2-1) unstable; urgency=low

  * New upstream release (Closes: #374079);
  * Bumped Standards-Version to 3.7.2 (no changes needed);
  * Updated watch file;
  * .bak files aren't deleted anymore (Closes: #357487);
  * Fixed "cummulative" typo (Closes: #355817).

 -- Nelson A. de Oliveira <naoliv@gmail.com>  Sat, 17 Jun 2006 16:33:57 -0300

optipng (0.5-1) unstable; urgency=low

  * Initial release (Closes: #347993).

 -- Nelson A. de Oliveira <naoliv@gmail.com>  Tue, 24 Jan 2006 12:32:55 -0200

=== debian/control ===
Source: optipng
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Nelson A. de Oliveira <naoliv@debian.org>
Build-Depends: cdbs, debhelper (>= 7), zlib1g-dev, libpng12-dev
Standards-Version: 3.8.4
Homepage: http://optipng.sourceforge.net/

Package: optipng
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: advanced PNG (Portable Network Graphics) optimizer
 OptiPNG is a PNG optimizer that recompresses the image files to a smaller
 size. It losslessly reduces the bit depth, the color type and the color
 palette of the image, runs a suite of compression methods and strategies,
 and selects the compression parameters that yield the smallest output file.
 It also recognizes several external file formats like BMP, GIF, TIFF and
 PNM (PBM, PGM, PPM).

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/class/makefile.mk
include /usr/share/cdbs/1/rules/debhelper.mk

DEB_MAKE_INSTALL_TARGET := install prefix=$(CURDIR)/debian/optipng/usr \
	mandir=$(CURDIR)/debian/optipng/usr/share/man

configure/optipng::
	./configure -with-system-zlib -with-system-libpng

## optipng 0.7.5

=== debian/changelog ===
optipng (0.7.5-1ubuntu0.1) wily-security; urgency=medium

  * SECURITY UPDATE: out of bounds read/writes via malformed image
    - debian/patches/CVE-2016-2191.patch: properly check bounds in
      src/pngxtern/pngxrbmp.c.
    - CVE-2016-2191
  * SECURITY UPDATE: harmless out-of-bounds read
    - debian/patches/CVE-2015-7802.patch: properly set last_byte in
      src/gifread/gifread.c.
    - CVE-2015-7802

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 13 Apr 2016 13:46:31 -0400

optipng (0.7.5-1) unstable; urgency=medium

  * New upstream release (Closes: #687770)
  * Bump Standards-Version to 3.9.5
  * Build-Depends on libpng-dev instead of libpng12-dev (Closes: #662457)
  * Switch to debhelper >= 9
  * Add Vcs-* fields
  * Set Debian PhotoTools as maintainer and add myself to Uploaders
  * Enable test suite
  * Update debian/README.source according the last change in sources
  * Switch debian/copyright to DEP5 format
  * Switch from CDBS to full debhelper
  * Install optipng-check tool in examples directory (Closes: #602091)

 -- Emmanuel Bouthenot <kolter@debian.org>  Wed, 11 Jun 2014 13:48:40 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,15 @@
 Section: graphics
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Nelson A. de Oliveira <naoliv@debian.org>
-Build-Depends: cdbs, debhelper (>= 7), zlib1g-dev, libpng12-dev
-Standards-Version: 3.8.4
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Uploaders:
+    Nelson A. de Oliveira <naoliv@debian.org>,
+    Emmanuel Bouthenot <kolter@debian.org>
+Build-Depends: debhelper (>= 9), zlib1g-dev, libpng-dev
+Standards-Version: 3.9.5
 Homepage: http://optipng.sourceforge.net/
+Vcs-Git: git://anonscm.debian.org/pkg-phototools/optipng.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/optipng.git
 
 Package: optipng
 Architecture: any

## optipng 0.7.6

=== debian/changelog ===
optipng (0.7.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Prevent integer overflow in minitiff_read_info() (CVE-2017-1000229)
    (Closes: #882032)
  * gifread: Detect indirect circular dependencies in LZW tables
    (CVE-2017-16938) (Closes: #878839)

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 07 Dec 2017 20:43:29 +0100

optipng (0.7.6-1) unstable; urgency=medium

  * New upstream release
    - fix CVE-2016-2191: Invalid write while processing delta escapes
      without any boundary checking (Closes: #820068)
    - fix CVE-2015-7802: Buffer overflow in global memory (Closes: #801700)
  * Enable hardening=+all build
  * Fix Vcs-(Git|Browser) fields to use secure URIs
  * Bump Standards-Version to 3.9.7
  * Add a patch to fix typo in manpage

 -- Emmanuel Bouthenot <kolter@debian.org>  Fri, 08 Apr 2016 23:13:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,15 @@
 Source: optipng
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders:
     Nelson A. de Oliveira <naoliv@debian.org>,
     Emmanuel Bouthenot <kolter@debian.org>
 Build-Depends: debhelper (>= 9), zlib1g-dev, libpng-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.7
 Homepage: http://optipng.sourceforge.net/
-Vcs-Git: git://anonscm.debian.org/pkg-phototools/optipng.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/optipng.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/optipng.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-phototools/optipng.git
 
 Package: optipng
 Architecture: any

=== debian/watch ===
version=3
http://sf.net/optipng/optipng-(.*)\.tar\.gz

## optipng 0.7.7

=== debian/changelog ===
optipng (0.7.7-2) unstable; urgency=medium

  * Switch debian/watch to version 4
  * Update debian/upstream/metadata
    - Remove useless HomePage field
    - Add Repository and Repository-Browse fields
  * Switch debhelper compatibility to 13
  * Bump Standards-Version to 4.6.0.1
  * Set Rules-Requires-Root to no
  * Remove Nelson A. de Oliveira <naoliv@debian.org> from Uploaders
    (Closes: #962112)

 -- Emmanuel Bouthenot <kolter@debian.org>  Sat, 11 Sep 2021 21:17:21 +0000

optipng (0.7.7-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-Git and Vcs-Browser with new repository on salsa.debian.org
  * Fix debian/copyright Format URI to use https
  * Switch debhelper compatibility to 12
  * Bump Standards-Version to 4.3.0
  * Add debian/upstream/metadata

 -- Emmanuel Bouthenot <kolter@debian.org>  Sat, 16 Feb 2019 01:14:15 +0000

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,17 @@
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders:
-    Nelson A. de Oliveira <naoliv@debian.org>,
     Emmanuel Bouthenot <kolter@debian.org>
-Build-Depends: debhelper (>= 9), zlib1g-dev, libpng-dev
-Standards-Version: 3.9.7
+Build-Depends:
+    debhelper (>= 13),
+    debhelper-compat (= 13),
+    zlib1g-dev,
+    libpng-dev
+Standards-Version: 4.6.0.1
+Rules-Requires-Root: no
 Homepage: http://optipng.sourceforge.net/
-Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/optipng.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-phototools/optipng.git
+Vcs-Git: https://salsa.debian.org/debian-phototools-team/optipng.git
+Vcs-Browser: https://salsa.debian.org/debian-phototools-team/optipng
 
 Package: optipng
 Architecture: any

=== debian/watch ===
version=4
http://sf.net/optipng/optipng-(.*)\.tar\.gz

## optipng 0.7.8+ds

=== debian/changelog ===
optipng (0.7.8+ds-1) unstable; urgency=medium

  [ xiao sheng wen ]
  * Team upload.
  * New upstream version
  * d/copyright:
      - update upstream year info to 2023
      - update cexcept.h path and year info
      - update debian year info to 2024
      - add Files-Excluded field for remove third_party
  * d/watch: add opts="dversionmangle=auto, repacksuffix=+ds"
  * d/gbp.conf: add pristine-tar = True, remove useless [import-orig]

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 01 Feb 2024 11:11:35 +0800

optipng (0.7.7-3) unstable; urgency=medium

  * Team upload

  [ Helmut Grohne ]
  * Fix FTCBFS: Export triplet-prefixed CC (Closes: 845817)

  [ xiao sheng wen ]
  * Bump Standards-Version: 4.6.2
  * d/control:
      - add Multi-Arch: foreign (Closes: #1002076)
      - Build-Depends remove debhelper (>= 13), useless
  * d/copyright: update year info to 2023
  * delete d/dirs, useless

 -- xiao sheng wen <atzlinux@sina.com>  Fri, 08 Sep 2023 18:39:40 +0800

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,18 @@
 Uploaders:
     Emmanuel Bouthenot <kolter@debian.org>
 Build-Depends:
-    debhelper (>= 13),
     debhelper-compat (= 13),
     zlib1g-dev,
-    libpng-dev
-Standards-Version: 4.6.0.1
+    libpng-dev,
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://optipng.sourceforge.net/
+Homepage: https://optipng.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/optipng.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/optipng
 
 Package: optipng
 Architecture: any
+Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: advanced PNG (Portable Network Graphics) optimizer
  OptiPNG is a PNG optimizer that recompresses the image files to a smaller

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
include /usr/share/dpkg/architecture.mk
ifeq ($(origin CC),default)
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif
export CC

override_dh_auto_configure:
	./configure -prefix=/usr -mandir=/usr/share/man -with-system-libs

override_dh_installchangelogs:
	dh_installchangelogs -k

%:
	dh $@

## optipng 7.9.1+ds

=== CMakeLists.txt ===
# CMake project for OptiPNG
#
# Copyright (C) 2025 Cosmin Truta and the Contributing Authors.
#
# OptiPNG is open-source software, distributed under the zlib license.
# Please see the accompanying LICENSE file.

cmake_minimum_required(VERSION 3.15...4.0)

project(OptiPNG
        VERSION 7.9.1
        DESCRIPTION "Advanced PNG optimizer"
        LANGUAGES C
)

#
# Public options
#

option(OPTIPNG_USE_SYSTEM_LIBS "Use the system libraries" OFF)

if(OPTIPNG_USE_SYSTEM_LIBS)
  option(OPTIPNG_USE_SYSTEM_PNG "Use the system libpng" ON)
  option(OPTIPNG_USE_SYSTEM_ZLIB "Use the system zlib" ON)
else()
  option(OPTIPNG_USE_SYSTEM_PNG "Use the system libpng" OFF)
  option(OPTIPNG_USE_SYSTEM_ZLIB "Use the system zlib" OFF)
endif()

option(OPTIPNG_BUILD_TESTS "Build the unit test programs" ON)

if(OPTIPNG_USE_SYSTEM_LIBPNG)
  message(FATAL_ERROR
          "Incorrect option: OPTIPNG_USE_SYSTEM_LIBPNG=${OPTIPNG_USE_SYSTEM_LIBPNG} "
          "(did you mean OPTIPNG_USE_SYSTEM_PNG=${OPTIPNG_USE_SYSTEM_LIBPNG})?"
  )
endif()
if(OPTIPNG_USE_SYSTEM_PNG AND NOT OPTIPNG_USE_SYSTEM_ZLIB)
  message(FATAL_ERROR
          "Incorrect option combination: "
          "OPTIPNG_USE_SYSTEM_PNG=${OPTIPNG_USE_SYSTEM_PNG} "
          "OPTIPNG_USE_SYSTEM_ZLIB=${OPTIPNG_USE_SYSTEM_ZLIB} "
          "(cannot use the system libpng without the system zlib)"
  )
endif()

#
# Other options
#

if(MSVC)
  if(CMAKE_MSVC_RUNTIME_LIBRARY)
    message(STATUS "Using the MSVC ${CMAKE_MSVC_RUNTIME_LIBRARY} runtime")
  else()
    set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
    message(STATUS "Using the MSVC MultiThreadedDLL runtime")
  endif()
endif()

#
# File lists
#

set(OPTIPNG_SOURCE_DIRECTORIES src/optipng third_party/cexcept)
set(OPTIPNG_SOURCES
    src/optipng/optipng.c
    src/optipng/optim.c
    src/optipng/bitset.c
    src/optipng/ioutil.c
    src/optipng/ratio.c
)
set(OPTIPNG_HEADERS
    src/optipng/optipng.h
    src/optipng/bitset.h
    src/optipng/ioutil.h
    src/optipng/ratio.h
)
if(WIN32)
  list(APPEND OPTIPNG_SOURCE_DIRECTORIES third_party/wildargs)
  list(APPEND OPTIPNG_SOURCES third_party/wildargs/wildargs.c)
  # TODO: Add third_party/wildargs/CMakeLists.txt
endif()
list(APPEND OPTIPNG_HEADERS third_party/cexcept/cexcept.h)
# TODO: Add third_party/cexcept/CMakeLists.txt

set(OPNGREDUC_SOURCE_DIRECTORIES src/opngreduc)
set(OPNGREDUC_SOURCES src/opngreduc/opngreduc.c)
set(OPNGREDUC_HEADERS src/opngreduc/opngreduc.h)

set(PNGXTERN_SOURCE_DIRECTORIES src/pngxtern)
set(PNGXTERN_SOURCES
    src/pngxtern/pngxio.c
    src/pngxtern/pngxmem.c
    src/pngxtern/pngxset.c
    src/pngxtern/pngxread.c
    src/pngxtern/pngxrbmp.c
    src/pngxtern/pngxrgif.c
    src/pngxtern/pngxrjpg.c
    src/pngxtern/pngxrpnm.c
    src/pngxtern/pngxrtif.c
)
set(PNGXTERN_HEADERS
    src/pngxtern/pngxtern.h
    src/pngxtern/pngxutil.h
)

#
# Libraries
#

set(OPTIPNG_LINK_LIBRARIES)

if(NOT OPTIPNG_USE_SYSTEM_ZLIB)
  set(OPTIPNG_VENDORING_ZLIB_EXTRAS "${CMAKE_SOURCE_DIR}/third_party/vendoring/zlib_extras")
  list(PREPEND CMAKE_MODULE_PATH "${OPTIPNG_VENDORING_ZLIB_EXTRAS}")
endif()
find_package(ZLIB REQUIRED)
set(OPTIPNG_LINK_LIBRARIES ZLIB::ZLIB ${OPTIPNG_LINK_LIBRARIES})

if(NOT OPTIPNG_USE_SYSTEM_PNG)
  set(OPTIPNG_VENDORING_PNG_EXTRAS "${CMAKE_SOURCE_DIR}/third_party/vendoring/libpng_extras")
  list(PREPEND CMAKE_MODULE_PATH "${OPTIPNG_VENDORING_PNG_EXTRAS}")
endif()
find_package(PNG REQUIRED)
set(OPTIPNG_LINK_LIBRARIES PNG::PNG ${OPTIPNG_LINK_LIBRARIES})

add_subdirectory(third_party/gifread gifread)
add_subdirectory(third_party/minitiff minitiff)
add_subdirectory(third_party/pnmio pnmio)
set(OPTIPNG_LINK_LIBRARIES gifread minitiff pnmio ${OPTIPNG_LINK_LIBRARIES})

#
# Targets
#

add_executable(
    optipng
    ${OPTIPNG_SOURCES}
    ${OPTIPNG_HEADERS}
    ${OPNGREDUC_SOURCES}
    ${OPNGREDUC_HEADERS}
    ${PNGXTERN_SOURCES}
    ${PNGXTERN_HEADERS}
)

target_link_libraries(
    optipng
    PRIVATE ${OPTIPNG_LINK_LIBRARIES}
)

target_include_directories(
    optipng
    PRIVATE ${OPTIPNG_SOURCE_DIRECTORIES}
            ${OPNGREDUC_SOURCE_DIRECTORIES}
            ${PNGXTERN_SOURCE_DIRECTORIES}
)

#
# Testing
#

if(OPTIPNG_BUILD_TESTS)
  enable_testing()

  # Smoke-test the optipng program.
  add_test(
      NAME optipng_help_and_version_test
      COMMAND optipng --help --version
  )
  add_test(
      NAME optipng_smoke_test
      COMMAND optipng -o1
                      --clobber
                      --out=pngtest.out.png
                      "${CMAKE_CURRENT_SOURCE_DIR}/src/optipng/testimg/pngtest.png"
  )

  # Test the bitset module.
  add_executable(
      optipng_bitset_test
      src/optipng/testprog/bitset_test.c
      src/optipng/bitset.c
      src/optipng/bitset.h
  )
  target_include_directories(
      optipng_bitset_test
      PRIVATE src/optipng
  )
  add_test(
      NAME optipng_bitset_test
      COMMAND optipng_bitset_test
  )

  # Test the ratio module.
  add_executable(
      optipng_ratio_test
      src/optipng/testprog/ratio_test.c
      src/optipng/ratio.c
      src/optipng/ratio.h
  )
  target_include_directories(
      optipng_ratio_test
      PRIVATE src/optipng
  )
  add_test(
      NAME optipng_ratio_test
      COMMAND optipng_ratio_test
  )
endif()

#
# Installation
#

include(GNUInstallDirs)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/optipng"
        DESTINATION "${CMAKE_INSTALL_BINDIR}"
)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/src/optipng/man/optipng.1"
        DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
)

=== third_party/gifread/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5...4.0)

project(gifread C)

option(GIFREAD_BUILD_TESTS "Build the gifread test programs" ON)

add_library(
    gifread
    STATIC gifread.c gifread.h
)

target_include_directories(
    gifread
    PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
)

if(${GIFREAD_BUILD_TESTS})
  enable_testing()
  add_executable(gifdump testprog/gifdump.c)
  target_link_libraries(
      gifdump
      PRIVATE gifread
  )
  add_test(
      NAME dump_compass_gif
      COMMAND gifdump "${CMAKE_CURRENT_SOURCE_DIR}/testimg/compass.gif"
  )
endif()

=== third_party/gifread/Makefile ===
# Generated from Makefile.in
# Preconfigured for Unix (generic)

.PRECIOUS: Makefile
.SUFFIXES: .c .o .a

srcdir = .

CC = cc
CFLAGS = -O2
CPP = $(CC) -E
CPPFLAGS =
LD = $(CC)
LDFLAGS = -s
AR = ar
ARFLAGS = cru
RANLIB = ranlib
LIBS =
RM_F = rm -f

GIFREAD_LIB = libgifread.a
GIFREAD_OBJS = gifread.o
GIFDUMP = ./gifdump$(EXEEXT)
GIFDUMP_OBJS = gifdump.o
GIFDUMP_OUT = *.gifdump.out

.PHONY: all
all: $(GIFREAD_LIB) $(GIFDUMP)

.PHONY: test
test: $(GIFDUMP)
	$(GIFDUMP) $(srcdir)/testimg/compass.gif > compass.gifdump.out
	-@echo gifdump test ... ok

.PHONY: check
check: test

.c.o:
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

$(GIFREAD_LIB): $(GIFREAD_OBJS)
	$(AR) $(ARFLAGS) $@ $(GIFREAD_OBJS)
	$(RANLIB) $@

$(GIFDUMP): $(GIFDUMP_OBJS) $(GIFREAD_LIB)
	$(LD) $(LDFLAGS) -o $@ $(GIFDUMP_OBJS) $(GIFREAD_LIB) $(LIBS)

gifread.o: $(srcdir)/gifread.c $(srcdir)/gifread.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

gifdump.o: $(srcdir)/testprog/gifdump.c $(srcdir)/gifread.h
	$(CC) -c -I$(srcdir) $(CPPFLAGS) $(CFLAGS) -o $@ $<

.PHONY: clean
clean:
	-$(RM_F) $(GIFREAD_LIB) $(GIFREAD_OBJS)
	-$(RM_F) $(GIFDUMP) $(GIFDUMP_OBJS) $(GIFDUMP_OUT)

.PHONY: distclean
distclean: clean

=== third_party/minitiff/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14...4.0)

project(minitiff
        VERSION 0.3
        DESCRIPTION "Minimal I/O interface to the Tagged Image File Format (TIFF)"
        LANGUAGES C
)

# Declare the public build options.
option(MINITIFF_BUILD_STATIC_LIBRARY "Build minitiff as a static library" ON)
option(MINITIFF_BUILD_SHARED_LIBRARY "Build minitiff as a shared library" OFF)
option(MINITIFF_BUILD_TESTS "Build the minitiff test programs" ON)

# Initialize the private build options.
if(${MINITIFF_BUILD_STATIC_LIBRARY} AND NOT ${MINITIFF_BUILD_SHARED_LIBRARY})
  set(MINITIFF_LIBRARY_TYPE STATIC)
elseif(${MINITIFF_BUILD_SHARED_LIBRARY} AND NOT ${MINITIFF_BUILD_STATIC_LIBRARY})
  # TODO: set(MINITIFF_LIBRARY_TYPE SHARED)
  message(SEND_ERROR
          "Unsupported option: "
          "MINITIFF_BUILD_SHARED_LIBRARY=${MINITIFF_BUILD_SHARED_LIBRARY} "
          "(the minitiff API is unstable)"
  )
else()
  message(SEND_ERROR
          "Incorrect option mix: "
          "MINITIFF_BUILD_STATIC_LIBRARY=${MINITIFF_BUILD_STATIC_LIBRARY}, "
          "MINITIFF_BUILD_SHARED_LIBRARY=${MINITIFF_BUILD_SHARED_LIBRARY}"
  )
endif()

# Build the minitiff library.
add_library(
    minitiff
    ${MINITIFF_LIBRARY_TYPE}
    tiffread.c
    tiffutil.c
    #tiffwrite.c
    minitiff.h
)
target_include_directories(
    minitiff
    PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
)

# Build and run the minitiff tests.
if(${MINITIFF_BUILD_TESTS})
  enable_testing()
  add_executable(tiff2pnm testprog/tiff2pnm.c)
  target_link_libraries(tiff2pnm PRIVATE minitiff)
  # TODO: add_test(tiff2pnm ...)
endif()

=== third_party/minitiff/Makefile ===
# Generated from Makefile.in
# Preconfigured for Unix (generic)

.PRECIOUS: Makefile
.SUFFIXES: .c .o .a

srcdir = .

CC = cc
CFLAGS = -O2
CPP = $(CC) -E
CPPFLAGS =
LD = $(CC)
LDFLAGS = -s
AR = ar
ARFLAGS = cru
RANLIB = ranlib
LIBS =
RM_F = rm -f

MINITIFF_LIB = libminitiff.a
MINITIFF_OBJS = tiffread.o tiffutil.o #tiffwrite.o
TIFF2PNM = tiff2pnm$(EXEEXT)
TIFF2PNM_OBJS = tiff2pnm.o

.PHONY: all
all: $(MINITIFF_LIB) $(TIFF2PNM)

.PHONY: test
test: $(TIFF2PNM)
	@echo TODO: run $(TIFF2PNM)

.PHONY: check
check: test

.c.o:
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

$(MINITIFF_LIB): $(MINITIFF_OBJS)
	$(AR) $(ARFLAGS) $@ $(MINITIFF_OBJS)
	$(RANLIB) $@

$(TIFF2PNM): $(TIFF2PNM_OBJS) $(MINITIFF_LIB)
	$(LD) $(LDFLAGS) -o $@ $(TIFF2PNM_OBJS) $(MINITIFF_LIB) $(LIBS)

tiffread.o: $(srcdir)/tiffread.c $(srcdir)/minitiff.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

tiffutil.o: $(srcdir)/tiffutil.c $(srcdir)/minitiff.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

#tiffwrite.o: $(srcdir)/tiffwrite.c $(srcdir)/minitiff.h
#	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

tiff2pnm.o: $(srcdir)/testprog/tiff2pnm.c $(srcdir)/minitiff.h
	$(CC) -c -I$(srcdir) $(CPPFLAGS) $(CFLAGS) -o $@ $<

.PHONY: clean
clean:
	-$(RM_F) $(MINITIFF_LIB) $(MINITIFF_OBJS)
	-$(RM_F) $(TIFF2PNM) $(TIFF2PNM_OBJS)

.PHONY: distclean
distclean: clean

=== third_party/pnmio/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14...4.0)

project(pnmio
        VERSION 0.4
        DESCRIPTION "I/O interface to the Portable Any Map (PNM) image format"
        LANGUAGES C
)

# Declare the public build options.
option(PNMIO_BUILD_STATIC_LIBRARY "Build pnmio as a static library" ON)
option(PNMIO_BUILD_SHARED_LIBRARY "Build pnmio as a shared library" OFF)
# TODO: option(PNMIO_BUILD_TESTS "Build the pnmio test programs" ON)

# Initialize the private build options.
if(${PNMIO_BUILD_STATIC_LIBRARY} AND NOT ${PNMIO_BUILD_SHARED_LIBRARY})
  set(PNMIO_LIBRARY_TYPE STATIC)
elseif(${PNMIO_BUILD_SHARED_LIBRARY} AND NOT ${PNMIO_BUILD_STATIC_LIBRARY})
  # TODO: set(PNMIO_LIBRARY_TYPE SHARED)
  message(SEND_ERROR
          "Unsupported option: "
          "PNMIO_BUILD_SHARED_LIBRARY=${PNMIO_BUILD_SHARED_LIBRARY} "
          "(the ${PROJECT_NAME} API is unstable)"
  )
else()
  message(SEND_ERROR
          "Incorrect option mix: "
          "PNMIO_BUILD_STATIC_LIBRARY=${PNMIO_BUILD_STATIC_LIBRARY}, "
          "PNMIO_BUILD_SHARED_LIBRARY=${PNMIO_BUILD_SHARED_LIBRARY}"
  )
endif()

# Initialize the source lists.
set(PNMIO_SOURCES pnmin.c pnmout.c pnmutil.c)
set(PNMIO_HEADERS pnmio.h)

# Build the pnmio library.
add_library(
    pnmio
    ${PNMIO_LIBRARY_TYPE}
    ${PNMIO_SOURCES}
    ${PNMIO_HEADERS}
)
target_include_directories(
    pnmio
    PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
)

=== third_party/pnmio/Makefile ===
# Generated from Makefile.in
# Preconfigured for Unix (generic)

.PRECIOUS: Makefile
.SUFFIXES: .c .o .a

srcdir = .

CC = cc
CFLAGS = -O2
CPP = $(CC) -E
CPPFLAGS =
LD = $(CC)
LDFLAGS = -s
AR = ar
ARFLAGS = cru
RANLIB = ranlib
LIBS =
RM_F = rm -f

PNMIO_LIB = libpnmio.a
PNMIO_OBJS = pnmin.o pnmout.o pnmutil.o

.PHONY: all
all: $(PNMIO_LIB)

.PHONY: test
test:
	@echo TODO: test $(PNMIO_LIB)

.PHONY: check
check: test

.c.o:
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

$(PNMIO_LIB): $(PNMIO_OBJS)
	$(AR) $(ARFLAGS) $@ $(PNMIO_OBJS)
	$(RANLIB) $@

pnmin.o: $(srcdir)/pnmin.c $(srcdir)/pnmio.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

pnmout.o: $(srcdir)/pnmout.c $(srcdir)/pnmio.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

pnmutil.o: $(srcdir)/pnmutil.c $(srcdir)/pnmio.h
	$(CC) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

.PHONY: clean
clean:
	-$(RM_F) $(PNMIO_LIB) $(PNMIO_OBJS)

.PHONY: distclean
distclean: clean

=== debian/changelog ===
optipng (7.9.1+ds-2) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version: 4.7.2
  * d/control: Build-Depends add cmake, Closes: #1111272, Thanks Gui Yue

 -- xiao sheng wen <atzlinux@debian.org>  Sat, 16 Aug 2025 22:25:44 +0800

optipng (7.9.1+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 7.9.1+ds
  * d/rules:
      - use --buildsystem=cmake
      - add export DEB_BUILD_MAINT_OPTIONS = hardening=+all
  * d/copyright:
      - update year info to 2025
      - update Files: third_party/gifread/* infos
      - add License: BSL-1.0 for third_party directory
  * refresh patches, delete d/p directory
  * d/doc-base: remove Format: PDF, add Format: Text, add new html file

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 14 Aug 2025 18:32:24 +0800

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,10 @@
     Emmanuel Bouthenot <kolter@debian.org>
 Build-Depends:
     debhelper-compat (= 13),
+    cmake,
     zlib1g-dev,
     libpng-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://optipng.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/optipng.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_installchangelogs:
	dh_installchangelogs -k

%:
	dh $@ --buildsystem=cmake

=== debian/watch ===
version=4

opts="dversionmangle=auto, repacksuffix=+ds" \
http://sf.net/optipng/optipng-(.*)\.tar\.gz
